RPL
( C:\Documents and Settings\cydeb\Desktop\circle\circ.S, part of the cr.HPP
project, created by <> on 8/8/2008 )



::

CK5&Dispatch

#11111
::
	 CHECKPICT GBUFF 6UNROLL                         ( GBUFF )
	 5ROLL COERCE                                    ( X0 )
	 5ROLL COERCE                                    ( Y0 )
	 5ROLL COERCE                                    ( Radius )
	 5ROLL % 90 %- %360 %MOD % 8.15 %* % 0.5 %+ COERCE    ( Angle Begin )
	 5ROLL % 90 %- %360 %MOD % 8.15 %* % 0.5 %+ COERCE    ( Angle End )

	
CODEM

SAVE

GOSBVL =POP#   % Angle End
R1=A.A
GOSBVL =POP#   % Angle Begin
R0=A.A
GOSBVL =POP#   % Radius
C=A.A
GOSBVL =CSLW5  % C va tre modifi par POP
GOSBVL =POP#   % Y0
B=A.A
GOSBVL =POP#   % X0

C=DAT1.A
D0=C           % D0 = GBUFF

GOSBVL =CSRW5  % C.A = Radius

GOSUB _Circle P=0
LOADRPL


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Circle asm toolbox                %
%                                                  %
% input: D0: @ grob                                %
%        Aa: Centre x                              %
%        Ba: Centre y                              %
%        Ca: Rayon                                 %
%        R0a: 360-AngleStart*8.4                   %
%        R1a: 360-AngleEnd*8.4                     %
% the circle must be in the -2047, 2047 square     %
% Grob can not be bigger than 2048 pixels          %
%                                                  %
% Uses: Carry, P, RSTK2                            %
%                 D0 (Last pix Plane1)             %
%                 D1 (Last pix plane2)             %
%                 R3a: +/- Line Width              %
%                 Cs: Pixel Mask                   %
%                 As: Undefine                     %
%                 Bs: Undefine                     %
% All functions are using standard bresenham algo  %
% D0 is pointing on the bit plan.                  %
% During the process,                              %
%    Am: 4*X Error                                 %
%    Bm: 4*Y Error                                 %
%    Cm: Error                                     %
%    Dm: 2* Radius                                 %
%    Ax: XCurrent                                  %
%    Bx: XMax (Grob Width)                         %
%    Cx: YCurrent                                  %
%    Dx: YMax (Grob Height)                        %
%    D0: Pointer on bit plan 1                     %
%    D1: Nb Pixel until we turn pixon ON/OFF       %
%    Cs: Pixel mask                                %
%    ST0: currently not drawing pixel (or drawing) %
%    Ds: nuber of pixon/pixof switch before bail out..%
%    Bs: bit feilf for quadrant to skip            %
%    R1a: Nb pixel for next series of Pixon/OFF    %
%    R3a: Line Width or - Line Width               %
%                                                  %
% The Bresenham algo is use to draw the circle.    %
% The original Bresenham use to compute the circle %
% Only on 1/8 of the circle and draw the other part%
% using symetrie. Doing a full pixon is quite slow %
% with a saturn, so, we are using 8 times          %
% bresenham to draw suxcecivly the 8 octants of    %
% the circle. Am, Bm and Cm are use to store the   %
% values needed by bresenam, Ax, Bx, Cx and Dx are %
% used to store the current pixel coordinates      %
% and the grob dimention to perform the cliping.   %
% D0 and Cs are use to point on the current        %
% pixel.                                           %
%                                                  %
% The algo we are using is:                        %
% X=2*Rayon-1                                      %
% Y=1                                              %
% cx=cx+rayon                                      %
% cy=cy                                            %
% Error = 0                                        %
% pixon(Cx, Cy)                                    %
% while Y<X do                                     %
% Begin                                            %
%   Error=Error+Y                                  %
%   Y=Y+2                                          %
%   cy=cy+1                                        %
%   If error>=X then                               %
%   Begin                                          %
%     error= error-X                               %
%     X=X-2                                        %
%     cx=cx-1                                      %
%   End                                            %
%   pixon(Cx, Cy)                                  %
% End;                                             %
% while X<>0 do                                    %
% Begin                                            %
%   Error=Error-X                                  %
%   X=X-2                                          %
%   cx=cx-1                                        %
%   If error<0 then                                %
%   Begin                                          %
%     error= error+Y                               %
%     Y=Y+2                                        %
%     cy=cy+1                                      %
%   End                                            %
%   pixon(Cx, Cy)                                  %
% End;                                             %
%                                                  %
% The same routine is used all the time, but       %
% a different Pixon routine is copied in IRAMBUFF  %
% for each type of line, and this routine is used  %
% to affect the pixels. the _Prepx routine are used%
% to copy the pixon routine in RAM. Note that to   %
% decrease teh amount of used register by this     %
% routine, the code is charged in Cm using LC with %
% P=3. in order to have a readable code, the LC    %
% mnemonic is not used, bu is replaced by the hex  %
% opcode: 3x where x is the number of nibbles to   %
% load in C-1. at the end of the routine, C[34] are%
% loaded with 00. This means the this part of the  %
% Ca register is lost                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*_Circle
?C=0.A RTY % Fast exit if radius = 0

ST=0.1 ST=0.2 ST=0.0 % by default, start with pixel not drawn... the ST1 and 2 are here for protection so the add do not change other flags
D=0.S D+1.S
B=0.S
AR1EX.A CR0EX.A ?C<A.A { ST=1.0 ACEX.A D+1.S } A-C.A AR0EX.A %Ca: start angle, Aa: radius, R0: A2-A1, R1: Cx
% D= C*A/512 -> D= Angle*8.9*R/512 -> A*2*pi*R/360 -> number of pixels from 0 to Angle
ST=0.3
?C#0.A
{
  D-1.S CSTEX C+1.A CSTEX
  ST=1.3
} SKELSE {

  % build a bitfeild for every quadran that needs to be skipped before we start painting
  ?ST=0.0 { { D=C.A LC 002D5 D-C.A EXITC B+1.S D-C.A EXIT EXITC B+2.S D-C.A
EXITC B+4.S D-C.A EXITC B+8.S } C+D.A }
  D=0.A
  ?ABIT=0.0 { D+C.A } C+C.A
  ?ABIT=0.1 { D+C.A } C+C.A
  ?ABIT=0.2 { D+C.A } C+C.A
  ?ABIT=0.3 { D+C.A } C+C.A
  ?ABIT=0.4 { D+C.A } C+C.A
  ?ABIT=0.5 { D+C.A } C+C.A
  ?ABIT=0.6 { D+C.A } C+C.A
  ?ABIT=0.7 { D+C.A } DSRB.A
  ?ABIT=0.8 { D+C.A } DSRB.A
  ?ABIT=0.9 { D+C.A } DSRB.A
  ?ABIT=0.10 { D+C.A } DSRB.A
  ?ABIT=0.11 { D+C.A } DSRB.A
  DSR.A
  C=D.A D1=C % D1: number of pixel to first change Ca: A2-A1
}

C=R0.A D=0.A
?ABIT=0.0 { D+C.A } C+C.A
?ABIT=0.1 { D+C.A } C+C.A
?ABIT=0.2 { D+C.A } C+C.A
?ABIT=0.3 { D+C.A } C+C.A
?ABIT=0.4 { D+C.A } C+C.A
?ABIT=0.5 { D+C.A } C+C.A
?ABIT=0.6 { D+C.A } C+C.A
?ABIT=0.7 { D+C.A } DSRB.A
?ABIT=0.8 { D+C.A } DSRB.A
?ABIT=0.9 { D+C.A } DSRB.A
?ABIT=0.10 { D+C.A } DSRB.A
?ABIT=0.11 { D+C.A } DSRB.A
DSR.A
C=D.A ?ST=0.3 { D1=C } ACEX.A AR1EX.A % R1: number of pixel from A1 to A2, Ca: radius, Aa: Center X

A+C.A                               % Compute cx (cx+Rayon)
C=0.M C+C.A CSL.A CSL.A CSL.W       % Cm=Rayon*2

D0+10 C=DAT0.X C=D.S D=C.W          % Dx: MaxY Dm: Rayon*2 Ds: nb pixel color changes...
D0+5 C=DAT0.A RSTK=C C+7.A CSRB.A CSRB.A CBIT=0.0 R3=C.A % Compute line width
D0+5

% Aa: cx, Ba: cy, Ca: line lenght, D0: @screen D0=D0+B*C+A/4. Do not modify Aa and Ba

% We must now compute the position of the first pixel
AD0EX ABEX.A               % D0: cx Ba: @Screen, Aa: cy Ca: line width
C+C.A
?ABIT=0.1 { B+C.A } C+C.A  % We Want: D0=@Pix+Y*Width+X/4,
?ABIT=0.2 { B+C.A } C+C.A  % Step 1: Compute B=B+Y*Width ( Width even <= 512 )
?ABIT=0.3 { B+C.A } C+C.A
?ABIT=0.4 { B+C.A } C+C.A
?ABIT=0.5 { B+C.A } C+C.A
?ABIT=0.6 { B+C.A } C+C.A
?ABIT=0.7 { B+C.A } C+C.A
?ABIT=0.8 { B+C.A } C+C.A
?ABIT=0.9 { B+C.A }
% D0: cx Ba: @Pixel, Aa: cy
CD0EX D0=C                 % Ca=X
P=C.0 CSRB.A CSRB.A B+C.A  % Compute pixel address
ABEX.A AD0EX               % Restore Ba=Ba, Aa=Aa, D0 point on pixel on plan 1
LC 1248124812481248 P=0    % Compute pixel mask

C=RSTK BCEX.A              % Bx: max X Cx: current y

{ ?ST=0.0 EXIT ?A>=B.X EXIT ?C>=D.X EXIT A=DAT0.S A!C.S DAT0=A.S } % Pixon ( With cliping )

% First quadrant. do we need to bypass this quadrant or not?
SB=0 BSRB.S ?SB=0 { } SKNC { GOTO .Do_Bypass_Q1 }
% test for bypass of this quadran..
% ok, quadrant needs bypassing, so X=X-Radius, Y=Y+Radius.
DSRC DSRC DSRC DSRB.A CDEX.A % Ca: radius
D+C.X A-C.X                  % Update current X and Y
% Also need to move the pixel pointer... and this without modifying ANY registers!
% need to do D0+R3*Radius+Radius/4 and also deal with the mask...
AD0EX ABEX.A AR3EX.A         % Ba: @ pixel, Aa: line width, Ca: radius B=B+A*C. note, A<512 and even
C+C.A
?ABIT=0.1 { B+C.A } C+C.A P=C.0
CSR.A B-C.A CSL.A C=P.0 % remove radius /4
?ABIT=0.2 { B+C.A } C+C.A
?ABIT=0.3 { B+C.A } C+C.A
?ABIT=0.4 { B+C.A } C+C.A
?ABIT=0.5 { B+C.A } C+C.A
?ABIT=0.6 { B+C.A } C+C.A
?ABIT=0.7 { B+C.A } C+C.A
?ABIT=0.8 { B+C.A }
C=P.0 { C-4.B EXITC CSRB.S ?C#0.S UP B-1.A C+8.S UPNC }
CSR.A CSR.A % restore C (radius)
AR3EX.A ABEX.A AD0EX           % restore updated D0, Aa and Ba
CDEX.A D+D.A DSLC DSLC DSLC  P=14 % restore Current Y, max Y and radius
SKIP {
*.Do_Bypass_Q1
C=D.M A=C.M             % X=Am=Rayon
C=0.M                   % Y=Cm=0
B=0.M                   % Er=0
A-1.M C+1.M             % Because the bresenham algo need to add -(X-1) or Y+1, we already add the 1 to X and Y
P=14
% Octant 1 From a=0 to - 45
{
  ?A<=C.M EXIT          % End of octant? X<Y
  B+C.M                 % er+Y
  C+2.M C+1.X           % Y+2, cy+1
  CR3EX.W               % cy+1 part2
  AD0EX A+C.A AD0EX
  CR3EX.W

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B<A.M                % if error >= X
  {
    B-A.M               % er - X
    A-2.M A-1.X         % X-2, cx-1
    CSRB.S ?C#0.S { C+8.S D0-1 } % cx-1 part2
  }                     % Else, error<0
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

% Octant 2. From a=-45 to -90
{
  ?A#0.P EXIT           % End of octan?
  B-A.M                 % er - X
  A-2.M A-1.X           % X-2, cx-1
  CSRB.S ?C#0.S { C+8.S D0-1 } % cx-1 part2

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B=0.P                % if B>0 then do nothing
  {                     % else,
    B+C.M C+2.M C+1.X   % er+Y, Y+2, cy+1
    CR3EX.W             % cy+1 part2
    AD0EX A+C.A AD0EX
    CR3EX.W
  }
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}
}

% Octant 3 From a=-90 to -135
% Doing the same thing again, but inverting Y and X
C=D.M A=C.M B=0.M C=0.M % ReInitializing values
A-1.M C+1.M             % Because the bresenham algo need to add -(X-1) or Y+1, we already add the 1 to X and Y
{
  ?A<=C.M EXIT          % End of octant? X<Y
  B+C.M                 % er+Y
  C+2.M A-1.X           % Y+2, cx-1
  CSRB.S ?C#0.S { C+8.S D0-1 } % cx-1 part2

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B<A.M                % if error >= X
  {
    B-A.M               % er - X
    A-2.M C-1.X         % X-2, cy-1
    CR3EX.W             % cy-1 part2
    AD0EX A-C.A AD0EX
    CR3EX.W
  }                     % Else, error<0
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

% Octant 4. From a=-135 to -180
{
  ?A#0.P EXIT           % End of octan?
  B-A.M                 % er - X
  A-2.M C-1.X           % X-2, cy-1
  CR3EX.W               % cy-1 part2
  AD0EX A-C.A AD0EX
  CR3EX.W

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B=0.P                % if B>0 then do nothing
  {                     % else,
    B+C.M C+2.M A-1.X   % er+Y, Y+2, cx-1
    CSRB.S ?C#0.S { C+8.S D0-1 } % cx-1 part2
  }
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

% Octant 5 From a=-180 to -225
% Doing the same thing again, but inverting Y and X again and differantly
C=D.M A=C.M B=0.M C=0.M % Reinitializing values
A-1.M C+1.M             % Because the bresenham algo need to add -(X-1) or Y+1, we already add the 1 to X and Y
{
  ?A<=C.M EXIT          % End of octant? X<Y
  B+C.M                 % er+Y
  C+2.M C-1.X           % Y+2, cy-1
  CR3EX.A               % cy-1 part2
  AD0EX A-C.A AD0EX
  CR3EX.A

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B<A.M                % if error >= X
  {
    B-A.M               % er - X
    A-2.M A+1.X         % X-2, cx+1
    C+C.S SKNC { C+1.S D0+1 } % cx+1 part2
  }                     % Else, error<0
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

% Octant 6. From a=-225 to -270
{
  ?A#0.P EXIT           % End of octan?
  B-A.M                 % er - X
  A-2.M A+1.X           % X-2, cx+1
  C+C.S SKNC { C+1.S D0+1 } % cx+1 part2

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B=0.P                % if B>0 then do nothing
  {                     % else,
    B+C.M C+2.M C-1.X   % er+Y, Y+2, cy-1
    CR3EX.A             % cy-1 part2
    AD0EX A-C.A AD0EX
    CR3EX.A
  }
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

% Octant 7 From a=-270 to -315
% Doing the same thing again, but inverting Y and X again and differantly
C=D.M A=C.M B=0.M C=0.M % Reinitializing values
A-1.M C+1.M             % Because the bresenham algo need to add -(X-1) or Y+1, we already add the 1 to X and Y
{
  ?A<=C.M EXIT          % End of octant? X<Y
  B+C.M                 % er+Y
  C+2.M A+1.X           % Y+2, cx+1
  C+C.S SKNC { C+1.S D0+1 } % cx+1 part2

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B<A.M                % if error >= X
  {
    B-A.M               % er - X
    A-2.M C+1.X         % X-2, cy+1
    CR3EX.A             % cy+1 part2
    AD0EX A+C.A AD0EX
    CR3EX.A
  }                     % Else, error<0
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

% Octant 8. From a=-315 to -360
{
  B-A.M                 % er - X
  A-2.M C+1.X           % X-2, cy+1
  CR3EX.A               % cy+1 part2
  AD0EX A+C.A AD0EX
  CR3EX.A

  D1-1 SKNC { CD1EX CR1EX.A CD1EX D-1.S RTNC CSTEX C+1.A CSTEX } % count pixels, turn pixelON Flag on/off as needed, update counter

  ?B=0.P                % if B>0 then do nothing
  {                     % else,
    B+C.M C+2.M A+1.X   % er+Y, Y+2, cx+1
    C+C.S SKNC { C+1.S D0+1 } % cx+1 part2
  }
  ?A#0.P EXIT           % End of octan?
  ?ST=0.0 UP ?A>=B.X UP ?C>=D.X UP A=DAT0.S A!C.S DAT0=A.S UPNC % Pixon ( With cliping )
}

P=0 RTN

ENDCODE

6DROP
;
;
